// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/20AOF16C500KR/driver/20aof16c500kr.h $
// $Rev: 52358 $
// $Date: 2023-01-12 10:04:31 -0600 (Thu, 12 Jan 2023) $

// 20AOF16C500KR: Device Driver: header file

#ifndef	__20AOF16C500KR_H__
#define	__20AOF16C500KR_H__

#include "gsc_common.h"
#include "gsc_pci9656.h"



// macros *********************************************************************

#define	AOF16C500KR_BASE_NAME				"20aof16c500kr"

// IOCTL command codes
#define	AOF16C500KR_IOCTL_REG_READ			OS_IOCTL_RW( 0, 12, gsc_reg_t)
#define	AOF16C500KR_IOCTL_REG_WRITE			OS_IOCTL_W ( 1, 12, gsc_reg_t)
#define	AOF16C500KR_IOCTL_REG_MOD			OS_IOCTL_W ( 2, 12, gsc_reg_t)
#define	AOF16C500KR_IOCTL_QUERY				OS_IOCTL_RW( 3,  4, s32)
#define	AOF16C500KR_IOCTL_INITIALIZE		OS_IOCTL   ( 4)
#define	AOF16C500KR_IOCTL_AUTO_CALIBRATE	OS_IOCTL   ( 5)
#define	AOF16C500KR_IOCTL_AUTO_CAL_STS		OS_IOCTL_R ( 6,  4, s32)
#define	AOF16C500KR_IOCTL_BUF_CLEAR			OS_IOCTL   ( 7)
#define	AOF16C500KR_IOCTL_BUF_MODE			OS_IOCTL_RW( 8,  4, s32)
#define	AOF16C500KR_IOCTL_BUF_OVER_DATA		OS_IOCTL_RW( 9,  4, s32)
#define	AOF16C500KR_IOCTL_BUF_OVER_FRAME	OS_IOCTL_RW(10,  4, s32)
#define	AOF16C500KR_IOCTL_BUF_STATUS		OS_IOCTL_R (11,  4, s32)
#define	AOF16C500KR_IOCTL_BUF_SIZE			OS_IOCTL_R (12,  4, s32)
#define	AOF16C500KR_IOCTL_BUF_THRESH		OS_IOCTL_RW(13,  4, s32)
#define	AOF16C500KR_IOCTL_BUF_THR_STS		OS_IOCTL_R (14,  4, s32)
#define	AOF16C500KR_IOCTL_BURST_ENABLE		OS_IOCTL_RW(15,  4, s32)
#define	AOF16C500KR_IOCTL_BURST_READY		OS_IOCTL_R (16,  4, s32)
#define	AOF16C500KR_IOCTL_BURST_TRIG_SRC	OS_IOCTL_RW(17,  4, s32)
#define	AOF16C500KR_IOCTL_CHANNEL_SEL		OS_IOCTL_RW(18,  4, s32)
#define	AOF16C500KR_IOCTL_CLOCK_ENABLE		OS_IOCTL_RW(19,  4, s32)
#define	AOF16C500KR_IOCTL_CLOCK_READY		OS_IOCTL_R (20,  4, s32)
#define	AOF16C500KR_IOCTL_CLOCK_SRC			OS_IOCTL_RW(21,  4, s32)
#define	AOF16C500KR_IOCTL_CLOCK_SW			OS_IOCTL   (22)
#define	AOF16C500KR_IOCTL_DATA_FORMAT		OS_IOCTL_RW(23,  4, s32)
#define	AOF16C500KR_IOCTL_DIO_DIR_OUT		OS_IOCTL_RW(24,  4, s32)
#define	AOF16C500KR_IOCTL_DIO_READ			OS_IOCTL_R (25,  4, s32)
#define	AOF16C500KR_IOCTL_DIO_WRITE			OS_IOCTL_RW(26,  4, s32)
#define	AOF16C500KR_IOCTL_FILTER			OS_IOCTL_RW(27,  4, s32)
#define	AOF16C500KR_IOCTL_GEN_A_ENABLE		OS_IOCTL_RW(28,  4, s32)
#define	AOF16C500KR_IOCTL_GEN_A_NDIV		OS_IOCTL_RW(29,  4, s32)
#define	AOF16C500KR_IOCTL_GEN_B_ENABLE		OS_IOCTL_RW(30,  4, s32)
#define	AOF16C500KR_IOCTL_GEN_B_NDIV		OS_IOCTL_RW(31,  4, s32)
#define	AOF16C500KR_IOCTL_GROUND_SENSE		OS_IOCTL_RW(32,  4, s32)
#define	AOF16C500KR_IOCTL_IRQ_SEL			OS_IOCTL_RW(33,  4, s32)
#define	AOF16C500KR_IOCTL_LED				OS_IOCTL_RW(34,  4, s32)
#define	AOF16C500KR_IOCTL_LOAD_READY		OS_IOCTL_R (35,  4, s32)
#define	AOF16C500KR_IOCTL_LOAD_REQUEST		OS_IOCTL   (36)
#define	AOF16C500KR_IOCTL_OUTPUT_MODE		OS_IOCTL_RW(37,  4, s32)
#define	AOF16C500KR_IOCTL_RANGE				OS_IOCTL_RW(38,  4, s32)
#define	AOF16C500KR_IOCTL_TRIGGER_SW		OS_IOCTL   (39)
#define	AOF16C500KR_IOCTL_TX_IO_ABORT		OS_IOCTL_R (40,  4, s32)
#define	AOF16C500KR_IOCTL_TX_IO_MODE		OS_IOCTL_RW(41,  4, s32)
#define	AOF16C500KR_IOCTL_TX_IO_OVR_DAT		OS_IOCTL_RW(42,  4, s32)
#define	AOF16C500KR_IOCTL_TX_IO_OVR_FRM		OS_IOCTL_RW(43,  4, s32)
#define	AOF16C500KR_IOCTL_TX_IO_TIMEOUT		OS_IOCTL_RW(44,  4, s32)
#define	AOF16C500KR_IOCTL_WAIT_CANCEL		OS_IOCTL_RW(45, 28, gsc_wait_t)
#define	AOF16C500KR_IOCTL_WAIT_EVENT		OS_IOCTL_RW(46, 28, gsc_wait_t)
#define	AOF16C500KR_IOCTL_WAIT_STATUS		OS_IOCTL_RW(47, 28, gsc_wait_t)
#define	AOF16C500KR_IOCTL_XCVR_OUTPUT		OS_IOCTL_RW(48,  4, s32)
#define	AOF16C500KR_IOCTL_XCVR_POL			OS_IOCTL_RW(49,  4, s32)
#define	AOF16C500KR_IOCTL_XCVR_TYPE			OS_IOCTL_RW(50,  4, s32)



//*****************************************************************************
// AOF16C500KR_IOCTL_REG_READ
// AOF16C500KR_IOCTL_REG_WRITE
// AOF16C500KR_IOCTL_REG_MOD
//
#define	AOF16C500KR_REG_ENCODE(s,o)			GSC_REG_ENCODE(GSC_REG_TYPE_BAR2,(s),(o))
// Parameter:	gsc_reg_t*
#define	AOF16C500KR_GSC_BCR					AOF16C500KR_REG_ENCODE(4,0x00)// Board Control Register
#define	AOF16C500KR_GSC_DIOPR				AOF16C500KR_REG_ENCODE(4,0x04)// Digital I/O Port Register
#define	AOF16C500KR_GSC_PSR					AOF16C500KR_REG_ENCODE(4,0x30)// Primary Status Register
#define	AOF16C500KR_GSC_ACR					AOF16C500KR_REG_ENCODE(4,0x34)// Assembly Configuration Register
#define	AOF16C500KR_GSC_AVR					AOF16C500KR_REG_ENCODE(4,0x38)// Auto Cal Values Register
#define	AOF16C500KR_GSC_BOOR				AOF16C500KR_REG_ENCODE(4,0x3C)// Buffered Output Operations Register
#define	AOF16C500KR_GSC_OBTR				AOF16C500KR_REG_ENCODE(4,0x40)// Output Buffer Threshold Register
#define	AOF16C500KR_GSC_OBSR				AOF16C500KR_REG_ENCODE(4,0x44)// Output Buffer Size Register
#define	AOF16C500KR_GSC_AOBR				AOF16C500KR_REG_ENCODE(4,0x48)// Analog Output Buffer Register
#define	AOF16C500KR_GSC_RAGR				AOF16C500KR_REG_ENCODE(4,0x4C)// Rate-A Generator Register
#define	AOF16C500KR_GSC_RBGR				AOF16C500KR_REG_ENCODE(4,0x50)// Rate-B Generator Register
#define	AOF16C500KR_GSC_OCR					AOF16C500KR_REG_ENCODE(4,0x54)// Output Configuration Register

//*****************************************************************************
// AOF16C500KR_IOCTL_QUERY
//
//	Parameter:	s32
//		Pass in a value from the list below.
//		The value returned is the answer to the query.

typedef enum
{
	AOF16C500KR_QUERY_AO_CONFIG,	// Analog Output Configuration.
	AOF16C500KR_QUERY_AUTO_CAL_MS,	// Max auto-cal period in ms.
	AOF16C500KR_QUERY_CHANNEL_MASK,	// Mask of valid channel enable bits.
	AOF16C500KR_QUERY_CHANNEL_MAX,	// Maximum number of channels supported.
	AOF16C500KR_QUERY_CHANNEL_QTY,	// The number of A/D channels.
	AOF16C500KR_QUERY_COUNT,		// Number of query options.
	AOF16C500KR_QUERY_CUSTOM_FEAT,	// Custom Features
	AOF16C500KR_QUERY_DEVICE_TYPE,	// Value from gsc_dev_type_t
	AOF16C500KR_QUERY_FGEN_MAX,		// Rate Generator maximum output rate.
	AOF16C500KR_QUERY_FGEN_MIN,		// Rate Generator minimum output rate.
	AOF16C500KR_QUERY_FIFO_SIZE,	// FIFO depth in 32-bit samples
	AOF16C500KR_QUERY_FILTER,		// See filter options below.
	AOF16C500KR_QUERY_FREF_DEFAULT,	// The default Fref value for the device.
	AOF16C500KR_QUERY_FSAMP_MAX,	// Maximum sample rate.
	AOF16C500KR_QUERY_FSAMP_MIN,	// Minimum sample rate.
	AOF16C500KR_QUERY_INIT_MS,		// Max initialize period in ms.
	AOF16C500KR_QUERY_NDIV_MAX,		// Maximum rate generator Ndiv value.
	AOF16C500KR_QUERY_NDIV_MIN,		// Maximum rate generator Ndiv value.
	AOF16C500KR_QUERY_RANGE,		// See voltage range options below.
	AOF16C500KR_QUERY_LAST			// Must be very last entry.

} aof16c500kr_query_t;

#define	AOF16C500KR_IOCTL_QUERY_ERROR		(-1)	// A query request is unknown of invalid.

// AOF16C500KR_QUERY_AO_CONFIG options: ACR D23
#define	AOF16C500KR_AO_CONFIG_DIFF			0	// Differential
#define	AOF16C500KR_AO_CONFIG_SE			1	// Single Ended

// AOF16C500KR_QUERY_CUSTOM_FEAT options: ACR D25-D27
// None defined at present.

// AOF16C500KR_QUERY_FILTER options: ACR D20-D21
#define	AOF16C500KR_FILTER_140K				0	// Type F1: DC-140KHz, Elliptic, 8th Order

// AOF16C500KR_QUERY_RANGE options: ACR D22-D23
#define	AOF16C500KR_RANGE_6_3				0	// +-6 and +-3
#define	AOF16C500KR_RANGE_10_5				1	// +-10 and +-5

//*****************************************************************************
// AOF16C500KR_IOCTL_INITIALIZE				BCR D31
//
//	Parameter:	None

//*****************************************************************************
// AOF16C500KR_IOCTL_AUTO_CALIBRATE			BCR D28
//
//	Parameter:	None

//*****************************************************************************
// AOF16C500KR_IOCTL_AUTO_CAL_STS			BCR D28, D29
//
//	Parameter:	s32*
//		One of the below values is returned.
#define	AOF16C500KR_AUTO_CAL_STS_ACTIVE		0
#define	AOF16C500KR_AUTO_CAL_STS_FAIL		1
#define	AOF16C500KR_AUTO_CAL_STS_PASS		2

//*****************************************************************************
// AOF16C500KR_IOCTL_BUF_CLEAR				BOOR D11
//
//	Parameter:	None.

//*****************************************************************************
// AOF16C500KR_IOCTL_BUF_MODE				BOOR D8
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AOF16C500KR_BUF_MODE_OPEN			0
#define	AOF16C500KR_BUF_MODE_CIRC			1

//*****************************************************************************
// AOF16C500KR_IOCTL_BUF_OVER_DATA			BOOR D16
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AOF16C500KR_BUF_OVER_DATA_CLR		0
#define	AOF16C500KR_BUF_OVER_DATA_CHK		(-1)

//		The service returns one of the below listed values.
#define	AOF16C500KR_BUF_OVER_DATA_NO		0
#define	AOF16C500KR_BUF_OVER_DATA_YES		1

//*****************************************************************************
// AOF16C500KR_IOCTL_BUF_OVER_FRAME			BOOR D17
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AOF16C500KR_BUF_OVER_FRAME_CLR		0
#define	AOF16C500KR_BUF_OVER_FRAME_CHK		(-1)

//		The service returns one of the below listed values.
#define	AOF16C500KR_BUF_OVER_FRAME_NO		0
#define	AOF16C500KR_BUF_OVER_FRAME_YES		1

//*****************************************************************************
// AOF16C500KR_IOCTL_BUF_STATUS				BOOR D12, D13, D15
//
//	Parameter:	s32
//		The service returns one of the below listed values.
#define	AOF16C500KR_BUF_STATUS_EMPTY		0
#define	AOF16C500KR_BUF_STATUS_AE			1
#define	AOF16C500KR_BUF_STATUS_AF			2
#define	AOF16C500KR_BUF_STATUS_FULL			3

//*****************************************************************************
// AOF16C500KR_IOCTL_BUF_SIZE				OBSR D0-D18
//
//	Parameter:	s32
//		Values returned are from zero to 256K.

//*****************************************************************************
// AOF16C500KR_IOCTL_BUF_THRESH				OBTR D0-D18
//
//	Parameter:	s32
//		Pass in any value from zero to 256K, or
//		-1 to read the current setting.

//*****************************************************************************
// AOF16C500KR_IOCTL_BUF_THR_STS			OBTR D20
//
//	Parameter:	s32
//		Values returned are as follows.
#define	AOF16C500KR_BUF_THR_STS_CLR			0
#define	AOF16C500KR_BUF_THR_STS_SET			1

//*****************************************************************************
// AOF16C500KR_IOCTL_BURST_ENABLE			BOOR D19
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AOF16C500KR_BURST_ENABLE_NO			0
#define	AOF16C500KR_BURST_ENABLE_YES		1

//*****************************************************************************
// AOF16C500KR_IOCTL_BURST_READY			BOOR D18
//
//	Parameter:	s32
//		The service returns one of the below listed values.
#define	AOF16C500KR_BURST_READY_NO			0
#define	AOF16C500KR_BURST_READY_YES			1

//*****************************************************************************
// AOF16C500KR_IOCTL_BURST_TRIG_SRC			OCR D20-D21
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AOF16C500KR_BURST_TRIG_SRC_RAG		0
#define	AOF16C500KR_BURST_TRIG_SRC_RBG		1
#define	AOF16C500KR_BURST_TRIG_SRC_EXT		2

//*****************************************************************************
// AOF16C500KR_IOCTL_CHANNEL_SEL			OCR D0-D15
//
//	Parameter:	s32
//		Pass in any valid bitwise combination, or
//		-1 to read the current setting.
//		The range for  4 channel devices is 0x00000 to 0x000F.
//		The range for  8 channel devices is 0x00000 to 0x00FF.
//		The range for 12 channel devices is 0x00000 to 0x0FFF.
//		The range for 16 channel devices is 0x00000 to 0xFFFF.

//*****************************************************************************
// AOF16C500KR_IOCTL_CLOCK_ENABLE			BOOR D5
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AOF16C500KR_CLOCK_ENABLE_NO			0
#define	AOF16C500KR_CLOCK_ENABLE_YES		1

//*****************************************************************************
// AOF16C500KR_IOCTL_CLOCK_READY			BOOR D6
//
//	Parameter:	s32
//		The service returns one of the below listed values.
#define	AOF16C500KR_CLOCK_READY_NO			0
#define	AOF16C500KR_CLOCK_READY_YES			1

//*****************************************************************************
// AOF16C500KR_IOCTL_CLOCK_SRC				OCR D18-D19
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AOF16C500KR_CLOCK_SRC_RAG			0
#define	AOF16C500KR_CLOCK_SRC_RBG			1
#define	AOF16C500KR_CLOCK_SRC_EXT			2

//*****************************************************************************
// AOF16C500KR_IOCTL_CLOCK_SW				BCR D20, BOOR D7
// The driver will wait upto the Tx I/O Timeout period for the bit clear.
//
//	Parameter:	None.

//*****************************************************************************
// AOF16C500KR_IOCTL_DATA_FORMAT			BCR D25
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AOF16C500KR_DATA_FORMAT_2S_COMP		0	// Twos Compliment
#define	AOF16C500KR_DATA_FORMAT_OFF_BIN		1	// Offset Binary

//*****************************************************************************
// AOF16C500KR_IOCTL_DIO_DIR_OUT			DIOPR D7, D15
//
//	Parameter:	s32
//		Values returned are as follows.
#define	AOF16C500KR_DIO_DIR_OUT_NONE		0x0000
#define	AOF16C500KR_DIO_DIR_OUT_D3_D0		0x0080
#define	AOF16C500KR_DIO_DIR_OUT_D7_D4		0x8000
#define	AOF16C500KR_DIO_DIR_OUT_D7_D0		0x8080

//*****************************************************************************
// AOF16C500KR_IOCTL_DIO_READ				DIOPR D0-D3, D8-D11
//
//	Parameter:	s32
//		Values returned are from zero to 0xFF.

//*****************************************************************************
// AOF16C500KR_IOCTL_DIO_WRITE				DIOPR D0-D3, D8-D11
//
//	Parameter:	s32
//		Pass in any value from zero to 0xFF, or
//		-1 to read the current setting.

//*****************************************************************************
// AOF16C500KR_IOCTL_FILTER					BCR D24
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AOF16C500KR_FILTER_DISABLE			0
#define	AOF16C500KR_FILTER_ENABLE			1

//*****************************************************************************
// AOF16C500KR_IOCTL_GEN_A_ENABLE			BCR D21
// AOF16C500KR_IOCTL_GEN_B_ENABLE			BCR D22
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AOF16C500KR_GEN_ENABLE_NO			0
#define	AOF16C500KR_GEN_ENABLE_YES			1

//*****************************************************************************
// AOF16C500KR_IOCTL_GEN_A_NDIV				RAG D0-D23
// AOF16C500KR_IOCTL_GEN_B_NDIV				RBG D0-D23
//
//	Parameter:	s32
//		Pass in any value from 98 to 0xFFFFFF, or
//		-1 to read the current setting.

//*****************************************************************************
// AOF16C500KR_IOCTL_GROUND_SENSE			BCR D6
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AOF16C500KR_GROUND_SENSE_DISABLE	0
#define	AOF16C500KR_GROUND_SENSE_REMOTE		1

//*****************************************************************************
// AOF16C500KR_IOCTL_IRQ_SEL
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AOF16C500KR_IRQ_AUTO_CAL_DONE		0x0001
#define	AOF16C500KR_IRQ_DIO0_L2H			0x0100
#define	AOF16C500KR_IRQ_BUF_THR_H2L			0x0200
#define	AOF16C500KR_IRQ_BUF_THR_L2H			0x0400
#define	AOF16C500KR_IRQ_LOAD_READY_H2L		0x0800
#define	AOF16C500KR_IRQ_LOAD_READY_L2H		0x1000
#define	AOF16C500KR_IRQ_BURST_READY			0x2000
#define	AOF16C500KR_IRQ_BUF_ERROR			0x4000
#define	AOF16C500KR_IRQ_ALL					0x7F01

//*****************************************************************************
// AOF16C500KR_IOCTL_LED					BCR D19
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AOF16C500KR_LED_OFF					0
#define	AOF16C500KR_LED_ON					1

//*****************************************************************************
// AOF16C500KR_IOCTL_LOAD_READY				BOOR D10
//
//	Parameter:	s32
//		The service returns one of the below listed values.
#define	AOF16C500KR_LOAD_READY_NO			0
#define	AOF16C500KR_LOAD_READY_YES			1

//*****************************************************************************
// AOF16C500KR_IOCTL_LOAD_REQUEST			BOOR D9
//	The driver will wait the write timeout for completion.
//
//	Parameter:	None

//*****************************************************************************
// AOF16C500KR_IOCTL_OUTPUT_MODE			BCR D18
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AOF16C500KR_OUTPUT_MODE_SEQ			0
#define	AOF16C500KR_OUTPUT_MODE_SIM			1

//*****************************************************************************
// AOF16C500KR_IOCTL_RANGE					OCR D16
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AOF16C500KR_RANGE_3					0
#define	AOF16C500KR_RANGE_5					1
#define	AOF16C500KR_RANGE_6					2
#define	AOF16C500KR_RANGE_10				3

//*****************************************************************************
// AOF16C500KR_IOCTL_TRIGGER_SW				BCR D23, BOOR D20
// The driver will wait upto the Tx I/O Timeout period for the bit clear.
//
//	Parameter:	None.

//*****************************************************************************
// AOF16C500KR_IOCTL_TX_IO_ABORT
//
//	Parameter:	s32*
//		The returned value is one of the below options.
#define	AOF16C500KR_IO_ABORT_NO				0
#define	AOF16C500KR_IO_ABORT_YES			1

//*****************************************************************************
// AOF16C500KR_IOCTL_TX_IO_MODE
//
//	Parameter:	s32
//		Pass in any of the gsc_io_mode_t options, or
//		-1 to read the current setting.
#define	AOF16C500KR_IO_MODE_DEFAULT			GSC_IO_MODE_PIO
// GSC_IO_MODE_PIO
// GSC_IO_MODE_BMDMA
// GSC_IO_MODE_DMDMA

//*****************************************************************************
// AOF16C500KR_IOCTL_TX_IO_OVR_DAT
//
//	Parameter:	s32
//		Pass in any valid value, or
//		-1 to read the current setting.
#define	AOF16C500KR_TX_IO_OVR_DAT_IGNORE	0
#define	AOF16C500KR_TX_IO_OVR_DAT_CHECK		1
#define	AOF16C500KR_TX_IO_OVR_DAT_DEFAULT	AOF16C500KR_TX_IO_OVR_DAT_CHECK

//*****************************************************************************
// AOF16C500KR_IOCTL_TX_IO_OVR_FRM
//
//	Parameter:	s32
//		Pass in any valid value, or
//		-1 to read the current setting.
#define	AOF16C500KR_TX_IO_OVR_FRM_IGNORE	0
#define	AOF16C500KR_TX_IO_OVR_FRM_CHECK		1
#define	AOF16C500KR_TX_IO_OVR_FRM_DEFAULT	AOF16C500KR_TX_IO_OVR_FRM_CHECK

//*****************************************************************************
// AOF16C500KR_IOCTL_TX_IO_TIMEOUT (in seconds)
//
//	Parameter:	s32
//		Pass in any value from the minimim to the maximim, the infinite option,
//		or -1 to read the current setting. The value -1 is returned if the
//		feature is not supported, but this should never happen.
#define	AOF16C500KR_IO_TIMEOUT_DEFAULT		10
#define	AOF16C500KR_IO_TIMEOUT_NO_SLEEP		0		// Do not sleep to wait for more data.
#define	AOF16C500KR_IO_TIMEOUT_MIN			0
#define	AOF16C500KR_IO_TIMEOUT_MAX			GSC_IO_TIMEOUT_MAX
#define	AOF16C500KR_IO_TIMEOUT_INFINITE		GSC_IO_TIMEOUT_INFINITE

//*****************************************************************************
// AOF16C500KR_IOCTL_WAIT_EVENT				all fields must be valid
// AOF16C500KR_IOCTL_WAIT_CANCEL			fields need not be valid
// AOF16C500KR_IOCTL_WAIT_STATUS			fields need not be valid
//
//	Parameter:	gsc_wait_t*
// gsc_wait_t.flags - see gsc_common.h
// gsc_wait_t.main - see gsc_common.h
// gsc_wait_t.gsc
#define	AOF16C500KR_WAIT_GSC_AUTO_CAL_DN	AOF16C500KR_IRQ_AUTO_CAL_DONE
#define	AOF16C500KR_WAIT_GSC_BUF_ERROR		AOF16C500KR_IRQ_BUF_ERROR
#define	AOF16C500KR_WAIT_GSC_BUF_THR_H2L	AOF16C500KR_IRQ_BUF_THR_H2L
#define	AOF16C500KR_WAIT_GSC_BUF_THR_L2H	AOF16C500KR_IRQ_BUF_THR_L2H
#define	AOF16C500KR_WAIT_GSC_BURST_READY	AOF16C500KR_IRQ_BURST_READY
#define	AOF16C500KR_WAIT_GSC_DIO0_L2H		AOF16C500KR_IRQ_DIO0_L2H
#define	AOF16C500KR_WAIT_GSC_LD_RDY_H2L		AOF16C500KR_IRQ_LOAD_READY_H2L
#define	AOF16C500KR_WAIT_GSC_LD_RDY_L2H		AOF16C500KR_IRQ_LOAD_READY_L2H
#define	AOF16C500KR_WAIT_GSC_ALL			AOF16C500KR_IRQ_ALL
// gsc_wait_t.alt flags
#define	AOF16C500KR_WAIT_ALT_ALL			0x0000
// gsc_wait_t.io
#define	AOF16C500KR_WAIT_IO_TX_ABORT		0x0001
#define	AOF16C500KR_WAIT_IO_TX_DONE			0x0002
#define	AOF16C500KR_WAIT_IO_TX_ERROR		0x0004
#define	AOF16C500KR_WAIT_IO_TX_TIMEOUT		0x0008
#define	AOF16C500KR_WAIT_IO_ALL				0x000F

//*****************************************************************************
// AOF16C500KR_IOCTL_XCVR_OUTPUT			OCR D17
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AOF16C500KR_XCVR_OUTPUT_DISABLE		0
#define	AOF16C500KR_XCVR_OUTPUT_ENABLE		1

//*****************************************************************************
// AOF16C500KR_IOCTL_XCVR_POL				OCR D23
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AOF16C500KR_XCVR_POL_DEF			0
#define	AOF16C500KR_XCVR_POL_INV			1

//*****************************************************************************
// AOF16C500KR_IOCTL_XCVR_TYPE				BCR D5
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AOF16C500KR_XCVR_TYPE_TTL			0
#define	AOF16C500KR_XCVR_TYPE_LVDS			1



#endif
