// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/20AOF16C500KR/include/20aof16c500kr_utils.h $
// $Rev: 52361 $
// $Date: 2023-01-12 10:09:42 -0600 (Thu, 12 Jan 2023) $

// 20AOF16C500KR: Utilities: header file

#ifndef	__20AOF16C500KR_UTILS_H__
#define	__20AOF16C500KR_UTILS_H__

#include "20aof16c500kr_api.h"
#include "gsc_utils.h"
#include "gsc_utils_pci.h"



// prototypes *****************************************************************

// API utility services

int	aof16c500kr_close_util		(int fd, int index, int verbose);
int aof16c500kr_init_util		(int verbose);
int aof16c500kr_ioctl_util		(int fd, int index, int verbose, int request, void* arg);
int	aof16c500kr_open_util		(int device, int share, int index, int verbose, int* fd);
int aof16c500kr_read_util		(int fd, int index, int verbose, void* dst, size_t bytes);
int	aof16c500kr_write_util		(int fd, int index, int verbose, const void* src, size_t bytes);

// IOCTL utility services

int	aof16c500kr_auto_cal_sts	(int fd, int index, int verbose, s32* get);						// AOF16C500KR_IOCTL_AUTO_CAL_STS
int	aof16c500kr_auto_calibrate	(int fd, int index, int verbose);								// AOF16C500KR_IOCTL_AUTO_CALIBRATE
int	aof16c500kr_buf_clear		(int fd, int index, int verbose);								// AOF16C500KR_IOCTL_BUF_CLEAR
int	aof16c500kr_buf_mode		(int fd, int index, int verbose, s32 set, s32* get);			// AOF16C500KR_IOCTL_BUF_MODE
int	aof16c500kr_buf_over_data	(int fd, int index, int verbose, s32 set, s32* get);			// AOF16C500KR_IOCTL_BUF_OVER_DATA
int	aof16c500kr_buf_over_frame	(int fd, int index, int verbose, s32 set, s32* get);			// AOF16C500KR_IOCTL_BUF_OVER_FRAME
int	aof16c500kr_buf_size		(int fd, int index, int verbose, s32* get);						// AOF16C500KR_IOCTL_BUF_SIZE
int	aof16c500kr_buf_status		(int fd, int index, int verbose, s32* get);						// AOF16C500KR_IOCTL_BUF_STATUS
int	aof16c500kr_buf_thr_sts		(int fd, int index, int verbose, s32* get);						// AOF16C500KR_IOCTL_BUF_THR_STS
int	aof16c500kr_buf_thresh		(int fd, int index, int verbose, s32 set, s32* get);			// AOF16C500KR_IOCTL_BUF_THRESH
int	aof16c500kr_burst_enable	(int fd, int index, int verbose, s32 set, s32* get);			// AOF16C500KR_IOCTL_BURST_ENABLE
int	aof16c500kr_burst_ready		(int fd, int index, int verbose, s32* get);						// AOF16C500KR_IOCTL_BURST_READY
int	aof16c500kr_burst_trig_src	(int fd, int index, int verbose, s32 set, s32* get);			// AOF16C500KR_IOCTL_BURST_TRIG_SRC
int	aof16c500kr_channel_sel		(int fd, int index, int verbose, s32 set, s32* get);			// AOF16C500KR_IOCTL_CHANNEL_SEL
int	aof16c500kr_clock_enable	(int fd, int index, int verbose, s32 set, s32* get);			// AOF16C500KR_IOCTL_CLOCK_ENABLE
int	aof16c500kr_clock_ready		(int fd, int index, int verbose, s32* get);						// AOF16C500KR_IOCTL_CLOCK_READY
int	aof16c500kr_clock_src		(int fd, int index, int verbose, s32 set, s32* get);			// AOF16C500KR_IOCTL_CLOCK_SRC
int	aof16c500kr_clock_sw		(int fd, int index, int verbose);								// AOF16C500KR_IOCTL_CLOCK_SW
int	aof16c500kr_data_format		(int fd, int index, int verbose, s32 set, s32* get);			// AOF16C500KR_IOCTL_DATA_FORMAT
int	aof16c500kr_dio_dir_out		(int fd, int index, int verbose, s32 set, s32* get);			// AOF16C500KR_IOCTL_DIO_DIR_OUT
int	aof16c500kr_dio_read		(int fd, int index, int verbose, s32* get);						// AOF16C500KR_IOCTL_DIO_READ
int	aof16c500kr_dio_write		(int fd, int index, int verbose, s32 set, s32* get);			// AOF16C500KR_IOCTL_DIO_WRITE
int	aof16c500kr_filter			(int fd, int index, int verbose, s32 set, s32* get);			// AOF16C500KR_IOCTL_FILTER
int	aof16c500kr_gen_a_enable	(int fd, int index, int verbose, s32 set, s32* get);			// AOF16C500KR_IOCTL_GEN_A_ENABLE
int	aof16c500kr_gen_a_ndiv		(int fd, int index, int verbose, s32 set, s32* get);			// AOF16C500KR_IOCTL_GEN_A_NDIV
int	aof16c500kr_gen_a_ndiv		(int fd, int index, int verbose, s32 set, s32* get);			// AOF16C500KR_IOCTL_GEN_A_NDIV
int	aof16c500kr_gen_b_enable	(int fd, int index, int verbose, s32 set, s32* get);			// AOF16C500KR_IOCTL_GEN_B_ENABLE
int	aof16c500kr_gen_b_ndiv		(int fd, int index, int verbose, s32 set, s32* get);			// AOF16C500KR_IOCTL_GEN_B_NDIV
int	aof16c500kr_ground_sense	(int fd, int index, int verbose, s32 set, s32* get);			// AOF16C500KR_IOCTL_GROUND_SENSE
int	aof16c500kr_initialize		(int fd, int index, int verbose);								// AOF16C500KR_IOCTL_INITIALIZE
int	aof16c500kr_irq_sel			(int fd, int index, int verbose, s32 set, s32* get);			// AOF16C500KR_IOCTL_IRQ_SEL
int	aof16c500kr_led				(int fd, int index, int verbose, s32 set, s32* get);			// AOF16C500KR_IOCTL_LED
int	aof16c500kr_load_ready		(int fd, int index, int verbose, s32* get);						// AOF16C500KR_IOCTL_LOAD_READY
int	aof16c500kr_load_request	(int fd, int index, int verbose);								// AOF16C500KR_IOCTL_LOAD_REQUEST
int	aof16c500kr_output_mode		(int fd, int index, int verbose, s32 set, s32* get);			// AOF16C500KR_IOCTL_OUTPUT_MODE
int	aof16c500kr_query			(int fd, int index, int verbose, s32 set, s32* get);			// AOF16C500KR_IOCTL_QUERY
int	aof16c500kr_range			(int fd, int index, int verbose, s32 set, s32* get);			// AOF16C500KR_IOCTL_RANGE
int	aof16c500kr_reg_mod			(int fd, int index, int verbose, u32 reg, u32 value, u32 mask);// AOF16C500KR_IOCTL_REG_MOD
int	aof16c500kr_reg_read		(int fd, int index, int verbose, u32 reg, u32* value);			// AOF16C500KR_IOCTL_REG_READ
int	aof16c500kr_reg_write		(int fd, int index, int verbose, u32 reg, u32 value);			// AOF16C500KR_IOCTL_REG_WRITE
int	aof16c500kr_trigger_sw		(int fd, int index, int verbose);								// AOF16C500KR_IOCTL_TRIGGER_SW
int	aof16c500kr_tx_io_abort		(int fd, int index, int verbose, s32* get);						// AOF16C500KR_IOCTL_TX_IO_ABORT
int	aof16c500kr_tx_io_mode		(int fd, int index, int verbose, s32 set, s32* get);			// AOF16C500KR_IOCTL_TX_IO_MODE
int	aof16c500kr_tx_io_ovr_dat	(int fd, int index, int verbose, s32 set, s32* get);			// AOF16C500KR_IOCTL_TX_IO_OVR_DAT
int	aof16c500kr_tx_io_ovr_frm	(int fd, int index, int verbose, s32 set, s32* get);			// AOF16C500KR_IOCTL_TX_IO_OVR_FRM
int	aof16c500kr_tx_io_timeout	(int fd, int index, int verbose, s32 set, s32* get);			// AOF16C500KR_IOCTL_TX_IO_TIMEOUT
int	aof16c500kr_wait_cancel		(int fd, int index, int verbose, gsc_wait_t* wait);				// AOF16C500KR_IOCTL_WAIT_CANCEL
int	aof16c500kr_wait_event		(int fd, int index, int verbose, gsc_wait_t* wait);				// AOF16C500KR_IOCTL_WAIT_EVENT
int	aof16c500kr_wait_status		(int fd, int index, int verbose, gsc_wait_t* wait);				// AOF16C500KR_IOCTL_WAIT_STATUS
int	aof16c500kr_xcvr_output		(int fd, int index, int verbose, s32 set, s32* get);			// AOF16C500KR_IOCTL_XCVR_OUTPUT
int	aof16c500kr_xcvr_pol		(int fd, int index, int verbose, s32 set, s32* get);			// AOF16C500KR_IOCTL_XCVR_POL
int	aof16c500kr_xcvr_type		(int fd, int index, int verbose, s32 set, s32* get);			// AOF16C500KR_IOCTL_XCVR_TYPE

// Auxiliary utility services

int	aof16c500kr_config_ao			(int fd, int index, int verbose, s32 fsamp);
int	aof16c500kr_fsamp_ao_compute	(int fd, int index, int verbose, s32 fsamp, s32* ndiv, double* rate);
int	aof16c500kr_fsamp_ao_report		(int fd, int index, int verbose, int chan, s32* fsamp);
int	aof16c500kr_fsamp_ao_report_all	(int fd, int index, int verbose, s32* fsamp);
int	aof16c500kr_id_device			(int fd, int index, int verbose);
int	aof16c500kr_id_driver			(void);

int	aof16c500kr_count_boards		(int verbose, int* get);
int	aof16c500kr_fsamp_ao_get		(int fd, int verbose, s32* get);
int	aof16c500kr_reg_list			(int fd, int detail);

const gsc_reg_def_t*				aof16c500kr_reg_get_def_id		(u32 reg);
const gsc_reg_def_t*				aof16c500kr_reg_get_def_index	(int index);
const char*							aof16c500kr_reg_get_desc		(u32 reg);
const char*							aof16c500kr_reg_get_name		(u32 reg);



#endif
