// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/20AOF16C500KR/samples/fsamp/perform.c $
// $Rev: 52365 $
// $Date: 2023-01-12 10:14:08 -0600 (Thu, 12 Jan 2023) $

// 20AOF16C500KR: Sample Application: source file

#include "main.h"



// macros *********************************************************************

#define	FILE_NAME				"fsamp.txt"



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int		errs	= 0;
	FILE*	file	= NULL;
	int		fsamp;
	s32		max		= 0;
	s32		min		= 0;
	s32		ndiv;
	double	rate;

	gsc_label("Fsamp Computation");
	printf("\n");
	gsc_label_level_inc();

	if (args->range == 0)
	{
		min		= args->fsamp;
		max		= args->fsamp;
	}
	else
	{
		errs	+= aof16c500kr_query(args->fd, -1, 0, AOF16C500KR_QUERY_FSAMP_MAX, &max);
		errs	+= aof16c500kr_query(args->fd, -1, 0, AOF16C500KR_QUERY_FSAMP_MIN, &min);
	}

	if (args->save)
	{
		file	= fopen(FILE_NAME, "w+b");

		if (file == NULL)
		{
			printf("FAIL <---  (unable to create %s)\n", FILE_NAME);
			errs	= 1;
		}
		else
		{
			fprintf(file, "# 20AOF16C500K Scan Rates\n");
			fprintf(file, "# Request   Produced\n");
			fprintf(file, "# ========  ==========\n");
		}
	}

	for (fsamp = min; fsamp <= max; fsamp++)
	{
		errs	+= aof16c500kr_fsamp_ao_compute(args->fd, -1, 1, args->fsamp, &ndiv, &rate);

		if (file)
			fprintf(file, "%10ld  %10.3f\n", (long) fsamp, (double) rate);
	}

	if (file)
		fclose(file);

	gsc_label_level_dec();
	return(errs);
}


