// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/20AOF16C500KR/samples/id/perform.c $
// $Rev: 52366 $
// $Date: 2023-01-12 10:14:27 -0600 (Thu, 12 Jan 2023) $

// 20AOF16C500KR: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _clocking_sources(void)
{
	gsc_label("Clocking Sources");
	printf("Rate-A Generator, Rate-B Generator, External, Software\n");
	return(0);
}



//*****************************************************************************
static int _trigger_sources(void)
{
	gsc_label("Triggering Sources");
	printf("Rate-A Generator, Rate-B Generator, External, Software\n");
	return(0);
}



//*****************************************************************************
static int _output_modes(void)
{
	gsc_label("Output Modes");
	printf("Simultaneous, Sequential\n");
	return(0);
}



//*****************************************************************************
static int _clocking_modes(void)
{
	gsc_label("Clocking Modes");
	printf("Continuous, Triggered Burst\n");
	return(0);
}



//*****************************************************************************
static int _transceivers(void)
{
	gsc_label("Control Transceivers");
	printf("LVDS, TTL\n");
	return(0);
}



//*****************************************************************************
static int _dio_ports(void)
{
	gsc_label("Digital I/O Ports");
	printf("8-bits, nibble-wise bidirectional\n");
	return(0);
}



//*****************************************************************************
static int _leds(void)
{
	gsc_label("LED");
	printf("Front Panel\n");
	return(0);
}



//*****************************************************************************
static int _id_device_bcfgr(const args_t* args)
{
	gsc_reg_def_t		list[2]	= { { NULL }, { NULL } };
	const gsc_reg_def_t*	ptr;

	int	errs	= 0;

	printf("\n");
	ptr	= aof16c500kr_reg_get_def_id(AOF16C500KR_GSC_ACR);

	if (ptr)
	{
		list[0]	= ptr[0];
		errs	= gsc_reg_list(args->fd, list, 1, aof16c500kr_reg_read);
	}
	else
	{
		errs++;
		printf(	"FAIL <---  (%d. aof16c500kr_reg_get_def_id, AOF16C500KR_GSC_ACR)\n",
				__LINE__);
	}

	return(errs);
}



//*****************************************************************************
static int _register_map(const args_t* args)
{
	int	errs;

	printf("\n");
	errs	= aof16c500kr_reg_list(args->fd, args->detail);
	printf("\n");
	return(errs);
}



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int	errs	= 0;
	int	i;

	gsc_label("Device Features");
	printf("\n");

	gsc_label_level_inc();

	errs	+= _output_modes();
	errs	+= _clocking_sources();
	errs	+= _trigger_sources();
	errs	+= _clocking_modes();
	errs	+= _transceivers();
	errs	+= _dio_ports();
	errs	+= _leds();

	for (i = 0; i < AOF16C500KR_QUERY_LAST; i++)
		errs	+= aof16c500kr_query(args->fd, -1, 1, i, NULL);

	gsc_label_level_dec();

	errs	+= _id_device_bcfgr(args);
	errs	+= _register_map(args);
	printf("\n");

	return(errs);
}


