// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/20AOF16C500KR/utils/util_buf_over_data.c $
// $Rev: 46528 $
// $Date: 2019-09-17 14:05:47 -0500 (Tue, 17 Sep 2019) $

// 20AOF16C500KR: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	aof16c500kr_buf_over_data
*
*	Purpose:
*
*		Provide a visual wrapper for the AOF16C500KR_IOCTL_BUF_OVER_DATA service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		set		This is the value to apply.
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int aof16c500kr_buf_over_data(int fd, int index, int verbose, s32 set, s32* get)
{
	char		buf[128];
	int			errs	= 0;
	const char*	ptr		= buf;
	int			ret;

	if (verbose)
		gsc_label_index("Buffer Overflow", index);

	if (set == -1)
	{
		ret		= aof16c500kr_ioctl(fd, AOF16C500KR_IOCTL_BUF_OVER_DATA, &set);
		errs	+= ret ? 1 : 0;
	}
	else
	{
		ret		= aof16c500kr_ioctl(fd, AOF16C500KR_IOCTL_BUF_OVER_DATA, &set);
		errs	+= ret ? 1 : 0;
		set		= -1;
		ret		= aof16c500kr_ioctl(fd, AOF16C500KR_IOCTL_BUF_OVER_DATA, &set);
		errs	+= ret ? 1 : 0;
	}

	if (verbose)
	{
		ptr	= (set) ? "Yes" : "No";
		printf("%s  (%s)\n", errs ? "FAIL <---" : "PASS", ptr);
	}

	if (get)
		get[0]	= set;

	return(errs);
}


