// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/20AOF16C500KR/utils/util_buf_thresh.c $
// $Rev: 46528 $
// $Date: 2019-09-17 14:05:47 -0500 (Tue, 17 Sep 2019) $

// 20AOF16C500KR: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	aof16c500kr_buf_thresh
*
*	Purpose:
*
*		Provide a visual wrapper for the AOF16C500KR_IOCTL_BUF_THRESH service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		set		This is the value to apply.
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int aof16c500kr_buf_thresh(int fd, int index, int verbose, s32 set, s32* get)
{
	int	errs;
	int	ret;

	if (verbose)
		gsc_label_index("Buffer Threshold", index);

	ret		= aof16c500kr_ioctl(fd, AOF16C500KR_IOCTL_BUF_THRESH, &set);
	errs	= ret ? 1 : 0;

	if (verbose)
	{
		printf(	"%s  (%ld sample%s)\n",
				errs ? "FAIL <---" : "PASS",
				(long) set,
				(set == 1) ? "" : "s");
	}

	if (get)
		get[0]	= set;

	return(errs);
}


